#ifndef MW_SESSION_I_H
#define MW_SESSION_I_H

#include <MWSession.h>
#include <MWMap.h>

class MWSessionI : public MW::MWSession
{
public:

    MWSessionI(const std::shared_ptr<MWMap>&, const std::string&, bool trace, const std::shared_ptr<Ice::Logger>& logger);

    virtual void setCallback(std::shared_ptr<MWMap::MWMapCallbackPrx>, const Ice::Current&) override;
    virtual long long send(std::string, const Ice::Current&) override;
    virtual void destroy(const Ice::Current&) override;

private:

    const std::shared_ptr<MWMap> _MWMap;
    const std::string _name;
    std::shared_ptr<MWMapCallbackAdapter> _callback;
    bool _destroy = false;
    std::mutex _mutex;
    const bool _trace;
    const std::shared_ptr<Ice::Logger> _logger;
};

#endif
